/********************************************
*  dv
*  16/24rbgf^VO}A/Dgp
*  1/10VgR@PGA:x1
*  t@X:2.37V
*  QVGAJ[OtBbNLCD
*@vWFNgF CurrentMonitor
*********************************************/
#include "p33FJ64GP802.h"
#include "colorlcd_libdsPICVH.h"
#include <stdlib.h>
#include "spi_lib.h"

/*** RtBM[Vݒ  40MHz ***/
_FOSCSEL(FNOSC_FRCPLL & IESO_OFF);		// Prim OSC
_FOSC(FCKSM_CSDCMD & IOL1WAY_OFF & OSCIOFNC_ON & POSCMD_NONE);
_FWDT(FWDTEN_OFF);
_FPOR(ALTI2C_OFF & FPWRT_PWR32);
_FICD(JTAGEN_OFF & ICS_PGD1);

/** AiOvf[^i[pobt@ **/
unsigned long Buffer1[512];		// CH1p
unsigned long Buffer2[512];		// CH2p
unsigned long Scale;
long Offset1, Offset2;
int Gain, Period, Count, Trig, Chanel, Chatta, Sync, Index, i, DFlag;

char MsgScrn[] = "X=xxx Y=xxx";	// fobOpW\
/* ^b`{^Wf[^ */
int Button[8][2] = {{150,720},{230,720},{330,710},{435,700},
					{750,120},{725,690},{90, 720},{95,130}};  
char MsgUp[] = {0xEB, 0};
char MsgDown[] = {0xED, 0};
/** ֐vg^CsO  **/
void SetupADC(void);
void SetupScreen(void);
int Getscreen(unsigned int chn);
void Process(int sw);
void Oscillo(void);
void AxisDraw(int _period);
int CheckBtn(int x, int y);
void itostring(char digit, unsigned int data, char *buffer);
void GetData(void);

/*********** C[` ***************/
int main(void)
{
	// Setup System
	OSCCON = 0x0100;				// FRCPLLw
	CLKDIV = 0x0000;				// FRC=1/2 PLLPOST=1/1
	PLLFBD = 0x0029;				// 43{@7.37MHz2~432 = 79.2MHz
	CS = 1;						// SPIsl
	SCK = 0;
	/* Setup PORT In/Out */
	TRISA = 0x0002;				// RA1 input
	TRISB = 0x001F;				// RB0-4 is input
	SetupScreen();
	/* t\̏ */
	lcd_Init();
	lcd_Clear(BLACK);
	/* ADC SPI Mode 0,0  */
	SetupADC();
	/* ^C}1ݒ 50msec ^b`XN[p */
	T1CON = 0x0030;				// 1:256 Tcy=25.25ns*256=6.46us
	PR1 = 7734;					// 6.46us*7735=50msec
	IFS0bits.T1IF = 0;			// 荞݃tONA
	IEC0bits.T1IE = 1;			// 荞݋
	SetupScreen();				// ADCݒύX
	/* ^C}Rݒ@vp */
	T3CON = 0x0010;				// 1:8 25.25ns*8=202ns
	PR3 = 4949;					// 202*4950=1msec
	IFS0bits.T3IF = 0;			// 荞݃tONA
	IEC0bits.T3IE = 1;			// 荞݋	
	/*** ϐ ***/
	DFlag = 1;					// \vtOIAŏɕ\
	Chanel = 0;
	Trig = 116;					// gKx
	Gain = 0;					// QCtO
	Period = 4;
	Count = 0;
	Chatta = 0;
	Sync = 0;
	Index = 0;
	Scale = 1;					// QCXP[
	Offset1 = 0x1000000;			// CH0pItZbg
	Offset2 = 0x20000;			// CH1pItZbg
	/* ^C}PJn */
	T1CONbits.TON = 1;
	T3CONbits.TON = 1;
	/****** C@[v@****/	
	while(1){
		if(DFlag){				// \v肩H
			Oscillo();			// \
			DFlag = 0;			// \vtONA
			delay_ms(500/(Period+1));		// 1bԊu
			T3CONbits.TON = 1;	// ^C}3ĊJ
		}
	}
}
/*****************************************************
*  IVXR[v\Aۑf[^\
*  gKoĂ̈ʒu320f[^\
*  gKvȂ΍ŏ320f[^\
*****************************************************/
void Oscillo(void){
	int i,x, Point;

	if(Sync == 0){
	/* gKȂ̏ꍇAŏ\@*/
		AxisDraw(Period);					// W\
		for(i=1; i<=320; i++){
			if((Chanel == 0)||(Chanel == 1))
				lcd_Line(i, Buffer1[i-1]+10, i, Buffer1[i]+10, GREEN);
			if((Chanel == 0)||(Chanel == 2))
				lcd_Line(i, Buffer2[i-1]+10, i, Buffer2[i]+10, MAGENTA);		
		}
	}
	/* gK̏ꍇ gK */
	else{
		Point = -1;						// ŏ̃f[^
		/* gK`FbN  */
		if(Sync == 1){
			for(x=0; x<190; x++){
				if((Buffer1[x] < Trig) && (Buffer1[x+5] >= Trig)){
					Point = x;
					continue;
				}
			}
		}
		else{
			for(x=0; x<190; x++){
				if((Buffer2[x] < Trig) && (Buffer2[x+5] >= Trig)){
					Point = x;
					continue;
				}
			}
		}	
		/* gKAg`\  */
		if(Point != -1){
			AxisDraw(Period);				// W\
			for(i=1; i<=320; i++){
				if((Chanel == 0)||(Chanel == 1))
					lcd_Line(i, Buffer1[i+Point-1]+10, i, Buffer1[i+Point]+10, GREEN);
				if((Chanel == 0)||(Chanel == 2))
					lcd_Line(i, Buffer2[i+Point-1]+10, i, Buffer2[i+Point]+10, MAGENTA);
			}
		}
	}
	Chatta = 0;
}
/******************************************
*  OtW,^b`{^̕\
*******************************************/
void AxisDraw(int _period)
{
	int i;
	
	/* XAYW,⏕\ */
	lcd_Clear(BLACK);
	for(i=0; i<319; i+=50)
		lcd_Line(i, 0, i, 236, PERPLE);			// Y\
	for(i=0; i<239; i+=50)
		lcd_Line(0, i+10, 319, i+10, PERPLE);	// X\
	/* \`lw{^\ */
	switch(Chanel){
		case 0:
			lcd_Str(2, 0, "12", RED, WHITE);	// `l\
			break;
		case 1:
			lcd_Str(2, 0, " 1", RED, WHITE);	// CH0̂ݕ\
			break;
		case 2:
			lcd_Str(2, 0, " 2", RED, WHITE);	// CH1̂ݕ\
		default: break;
	}
	/* gK`lI{^\ */
	switch(Sync){
		case 0:
			lcd_Str(5, 0, "Trg", RED, WHITE);	// gKȂ
			break;
		case 1:
			lcd_Str(5, 0, "CH1", BLACK, GREEN);	// CH0gK
			break;
		case 2:
			lcd_Str(5, 0, "CH2", BLACK, MAGENTA);// CH1gK
		default: break;
	}
	/* QCI{^\, dPʕ\ */
	switch(Gain){
		case 0:
			lcd_Str(9, 0, " x1", RED, WHITE);		// 1{
			Scale = 1;
			lcd_Str(0, 1, "100uA", GREEN, BLACK);	// CH0 100umAP	
			lcd_Str(21, 1, "10mA", MAGENTA, BLACK);	// CH1 10mAP
			break;
		case 1:
			lcd_Str(9, 0, "x10", RED, WHITE);		// 10{
			Scale = 10;
			lcd_Str(0, 1, "10uA", GREEN, BLACK);	// CH0 10uAP
			lcd_Str(21, 1, "1mA", MAGENTA, BLACK);	// CH1 1mAP
			break;
		case 2:
			lcd_Str(9, 0, "100", RED, WHITE);		// 100{
			Scale = 100;
			lcd_Str(0, 1, "1uA", GREEN, BLACK);		// CH0 1uAP
			lcd_Str(21, 1, "0.1mA", MAGENTA, BLACK);	// CH1 0.1mAP
			break;
//		case 3:
//			lcd_Str(9, 0, "500", RED, WHITE);		// 500{
//			Scale = 500;
//			lcd_Str(0, 1, "0.2uA", GREEN, BLACK);	// CH0 2uAP
//			lcd_Str(21, 1, "2uA", MAGENTA, BLACK);	// CH1 200uAP
//			break;
		default: break;	
	}
	/* ԑI{^\ */
	lcd_Str(14, 0, "Scan", RED, WHITE);		// I{^
	switch(_period){
		case 0:							// 202*50=10.1us*990=10msec/dec
			lcd_Str(18, 0, " 10ms/d", CYAN, BLACK);
			PR3 = 989;					// 
			break;
		case 1:							// 10.1us*1980=20msec/dec
			lcd_Str(18, 0, " 20ms/d", CYAN, BLACK);
			PR3 = 1979;					// 
			break;
		case 2:							// 10.1us*4950=50msec/dec 
			lcd_Str(18, 0, " 50ms/d", CYAN, BLACK);
			PR3 = 4949;					// 
			break;
		case 3:							// 10.1use*9901=100msec/dec
			lcd_Str(18, 0, "100ms/d", CYAN, BLACK);
			PR3 =9900;					// 
			break;
		case 4:							// 10.1use*19802=200msec/dec
			lcd_Str(18, 0, "200ms/d", CYAN, BLACK);
			PR3 =19801;					// 
			break;
		default:
			break;
	}
	/* gKxw{^\ */
	lcd_Line(310, Trig, 319, Trig, YELLOW);
	lcd_Str(25, 0, MsgUp, BLACK, WHITE);
	lcd_Str(25, 16, MsgDown, BLACK, WHITE);
	/* ItZbg{^\  */
	if(Chanel == 1){
		lcd_Str(0, 0, MsgUp, BLACK, GREEN);
		lcd_Str(0, 16, MsgDown, BLACK, GREEN);
	}
	if(Chanel == 2){
		lcd_Str(0, 0, MsgUp, BLACK, MAGENTA);
		lcd_Str(0, 16, MsgDown, BLACK, MAGENTA);
	}	
}
/*******************************************************************************/
/******************************************
*@^C}3荞ݏ@ݒ
*  f[^͏
******************************************/
void __attribute__((interrupt, auto_psv)) _T3Interrupt(void)
{
	IFS0bits.T3IF = 0;			// 荞݃tONA
	/* ADCf[^͏ */
	GetData();
	Index++;						// obt@i[pCfbNXXV
	if(Index >= 512){				// obt@tH
		Index = 0;				// CfbNXZbg
		DFlag = 1;				// \vtOI
		T3CONbits.TON = 0;		// ^C}3~
	}
}
/************************************************
* f^VO}ϊʓ͊֐
* 茋 24bit
*@@Value = (Vin/2.37)*0x800000*Gain*3
*@@Vin = (Value*2.37)/(0x800000*Gain*3)
* ͐ GAIN=32{̏ꍇ
* @Max= 0.5V/32 = 15mV@10̂Ƃ1.5mA
*   Max= 0.5V/4 = 100mV@1̂Ƃ100mAMax
* dXP[
*@@2.37V/32*3 = 24mVMax@
*@@0.8/32V=25mV͂ŃtXP[ƂȂ
************************************************/
void GetData(void){
	unsigned char data00, data01, data02;
	unsigned char data10, data11, data12;
	unsigned long temp;

	while(PORTBbits.RB4);			// fB[s҂
	/* CH0f[^ */
	CS = 0;						// CSANeBu
	SPIOut(0x01);					// WX^#0w̓
	data00 = SPIRcv();			// CH0 ʃoCg
	data01 = SPIRcv();			// CH0 ʃoCg
	data02 = SPIRcv();			// CH0 ʃoCg
	data10 = SPIRcv();			// CH1 ʃoCg
	data11 = SPIRcv();			// CH1 ʃoCg
	data12 = SPIRcv();			// CH1 ʃoCg
	CS = 1;						// CS
	/* CH0 charlongɕϊ ItZbgoCi */
	temp = data00*0x1000000+data01*0x10000+data02*0x100+0x80000000+Offset1;
	if(temp < 0x80000000)			// ̒l0Ƃ
		temp = 0x80000000;
	/* CH0 24rbg8rbgɏk XP[ϊ*/
	Buffer1[Index] = (temp - 0x80000000)/(0x198000/Scale);
	if(Buffer1[Index] >= 229)		// \OȂ
		Buffer1[Index] = 229;
	/* CH1 charlongɕϊ ItZbgoCi*/
	temp = data10*0x1000000+data11*0x10000+data12*0x100+0x80000000+Offset2;
	if(temp < 0x80000000)			// ̒l0Ƃ
		temp = 0x80000000;
	/* CH1 24rbg8rbg13rbggp XP[ϊ*/
	Buffer2[Index] = (temp - 0x80000000)/(0x200000/Scale);
	if(Buffer2[Index] >= 229)		// l
		Buffer2[Index] = 229;
}
/*******************************************
*  f^VO}֐
*  CH0ACH1ƂQCő@BOOSTI
*******************************************/
void SetupADC(void)
{
	/** Reset ADC **/
	CS = 0;
	SPIOut(0x16);					// WX^#Bw
	SPIOut(0xC0);					// Reset
	CS = 1;
	delay_ms(1);					// wait 1msec
	/** Configure ADC **/
	CS = 0;
	SPIOut(0x0E);					// WX^#7w
	SPIOut(0x00);					// PHASE Reg 00
//	SPIOut(0x18);					// GAIN CH0,1Ƃ x1  BOOST On
//	SPIOut(0xBD);					// GAIN CH0, 1Ƃx32 BOOST On
	SPIOut(0x5D);					// GAIN CH0x32 CH1x4 BOOST On
	SPIOut(0x8C);					// STATUS TYPEwADRsL_
	SPIOut(0x3C);					// CONFIG1 AMCLK=MCLK/1, 256 Over, 24bit
	SPIOut(0x0C);					// CONFIG2 No RESET, DITHER On, VREF Int, XTmode
	CS = 1;
}

/***************************************************************/
/******************************************
*  ^C}1荞ݏ(50msec)
*  ^b`XN[@AiO 
*******************************************/
void __attribute__((interrupt, auto_psv)) _T1Interrupt(void)
{
	static int i, Xset, Yset, Xold, Yold;

	IFS0bits.T1IF = 0;				// 荞݃tONA
	/* ^b`XN[pADCݒ */
	SetupScreen();
	// X+=B2(AN4) X-=B0 Y+=B3(AN5) Y-=B1
	/*** XW ****/
	TRISBbits.TRISB3 = 0;				// RB3 RB1 is output
	TRISBbits.TRISB1 = 0;
	LATBbits.LATB3 = 0;				// Set Voltage
	LATBbits.LATB1 = 1;
	TRISBbits.TRISB2 = 1;				// RB0,RB2 input
	TRISBbits.TRISB0 = 1;
	for(i=0; i<50; i++)				// [d҂ 11usec
		Nop();
	Xset = Getscreen(4);				// Wl擾
	/**** YẂ@****/
	TRISBbits.TRISB0 = 0;				// RB2,RB0 output
	TRISBbits.TRISB2 = 0;
	LATBbits.LATB0 = 1;				// Set Voltage
	LATBbits.LATB2 = 0;
	TRISBbits.TRISB1 = 1;				// RB3, RB1 is input
	TRISBbits.TRISB3 = 1;
	for(i=0; i<50; i++)				// [d҂ 11usec
		Nop();
	Yset = Getscreen(5);				// Wl擾
	/*** ^b`ĂȂƂ̉ ***/
	if((Xset > 40)&&(Yset > 60)){
		/*** mȃ^b`̌o@**/
		if((abs(Xset - Xold) < 15) && abs(Yset - Yold) < 15){
			Count++;
			if((Count >= 3)&&(Chatta==0)){
				Count = 0;
				Process(CheckBtn(Xset, Yset));
				if(Chatta)
					AxisDraw(Period);	// W\	
			}
		}
		else
			Count = 0;
		Xold = Xset;
		Yold = Yset;
	}
}
/********************************
*   W擾s֐
********************************/
int Getscreen(unsigned int chn)
{
	int i;

	AD1CON1bits.ADON = 0;
	AD1CHS0 = chn;				// Select Channel
	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;
	for(i=0; i<50; i++)			// Wait Aquisition 11usec
		Nop();
	AD1CON1bits.SAMP = 0;			// A/D convert start
	while(!AD1CON1bits.DONE);		// wait conversion
	return(ADC1BUF0);				// return result
}
/****************************************
*  ^b`XN[pݒ
****************************************/
void SetupScreen(void)
{
	/* ADC̐ݒ */
	AD1CON1bits.ADON = 0;
	AD1CON1 = 0x0000;				// ADItA蓮
	AD1CON2 = 0;					// AVdd, AVss, SCANȂ,MUXÂ
	AD1CON3 = 0x0304;				// 3Tad , Tad = 5*Tcy
	AD1CON4 = 0;					// 1word DMAobt@
	AD1CHS123 = 0;				// TvȂ
 	AD1CHS0 = 0x0000;				// `lI
	AD1PCFGL = 0xFFC3;			// AN2-5 is analog
	AD1CSSL = 0;					// XLȂ
	AD1CON1bits.ADON = 1;			// ADL

}
/****************************************
* ^b`{^菈
****************************************/
int CheckBtn(int x, int y)
{
	int i, btn;
	/*** ^b`Wʒu\ifobOp)@****/
//	itostring(3, x, MsgScrn+2);
//	itostring(3, y, MsgScrn+8);
//	lcd_Str(5, 16, MsgScrn, RED, WHITE);
	/** {^`FbN **/
	btn = -1;
	for(	i=0; i<8; i++){
		if((x > Button[i][0]-30)&&(x <	Button[i][0]+30)){
			if((y > Button[i][1]-20)&&(y < Button[i][1]+20))
				btn = i;
		}
	}
	return(btn);
}
/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
		buffer--;					// |C^[P
		*buffer = (data % 10) + '0';	// ASCII
		data = data / 10;				// ̌
	}
}	
/********************************************
*  XCb`Ƃ̏
*   SW1:`l\I 0:1+2 1:1 2:2
*   SW2:gKxAbv
*   SW3:gKx_E
*   SW4:ύX
*   SW5:
*********************************************/
void Process(int sw)
{
	switch(sw){
		case 0:						// `l\XV
			Chanel++;
			if(Chanel == 3)
				Chanel = 0;
			Chatta = 1;
			break;
		case 1:						// gKL
			Sync++;
			if(Sync > 2)
				Sync = 0;
			Chatta = 1;
			break;
		case 2:						// XP[ύX
			Gain++;
			if(Gain > 2)
				Gain = 0;
			Chatta = 1;
			break;
		case 3:						// ԎύX
			Period++;
			if(Period > 4)
				Period = 0;
			Chatta = 1;
			break;
		case 4:						// gK_E
			if(Trig > 5)
				Trig -=5;
			lcd_Line(310, Trig, 319, Trig, YELLOW);
			break;
		case 5:						// gKAbv
			if(Trig < 234)
				Trig +=5;
			lcd_Line(310, Trig, 319, Trig, YELLOW);
			break;
		case 6:						// ItZbgAbv
			if(Chanel == 1)
				Offset1 += 0x40000;
			if(Chanel == 2)
				Offset2 += 0x40000;
			break;
		case 7:						// ItZbg_E
			if(Chanel == 1)
				Offset1 -= 0x40000;
			if(Chanel == 2)
				Offset2 -= 0x40000;
			break;
		default:
			break;
	}
}

